; Boot writer 0.02
; (C) 2002-2005, Andreas Berg. All Rights Reserved.

; This program writes "boot.bin" (512 bytes) to a floppy disks first sector 
; (head 0, cylinder 0)

; Set up com program
.model tiny
.com
.code
org 100h

; Init CS and DS registers
push cs
pop  ds

; Print title text
lea   si,title
call  print_String

; Open file...
mov   ah,3dh
mov   al,0
lea   dx,file
int   21h

jnc   fileOK

; Can not access file!
lea   si,accessDenied
call  print_String

jmp  done

fileOK:
mov   [handle],ax

; Get Buffer (read from file)
mov   ah,3fh
lea   dx,buf
mov   cx,512
mov   bx,[handle]
int   21h

; Write boot sector to disk
mov  ax,0301h 
mov  ch,0
mov  cl,1
mov  dh,0
mov  dl,0    ; Drive (0 = A, 1 = B,... )
lea  bx,buf  ; 512 byte buffer
int  13h

jnc   writeOK

; Could not write Boot sector
lea   si,bootError
call  print_String
jmp   done

writeOK:
lea   si,bootOK
call  print_String

done:
int   20h

print_String:
   mov       al,byte ptr [si]
   cmp       al,0
   je        print_done
   mov       ah,0eh
   mov       bh,0
   int       10h
   inc       si
   jmps      print_String
print_done:
ret

buf          array byte 0, 512

file         db   'boot.bin',0
title        db   'Boot writer 0.02',13,10
             db   '(C) 2002-2005, Andreas Berg. All Rights Reserved.',13,10,13,10,0
handle       dw   0

accessDenied db 'Can not access the boot file! :(',13,10,0
bootError    db 'Could not write boot sector! :(',13,10,0
bootOK       db 'Boot sector was written successfully! :)',13,10,0

end
