{ Alias (names & characters)
 (C) 2005-2012, Andreas Berg. All Rights Reserved. }
unit _alias;

interface

uses
 _common;

type
 TAlias = record
    NewName        : string;
    TargetName     : string;
 end;
 TAliasChar = record
    NewChar        : char;
    TargetChar     : char;
 end;

var
 AliasList         : array of TAlias;
 AliasCount        : TDefValue;

 AliasCharList     : array of TAliasChar;
 AliasCharCount    : TDefValue;

procedure InitAlias;

procedure AddAlias(newN, targetN: string);
procedure AddAliasChar(newC, targetC: char);

implementation

procedure InitAlias;
begin
   SetLength(AliasList, 1);
   AliasCount:= 0;

   SetLength(AliasCharList, 1);
   AliasCharCount:= 0;
end;



procedure AddAlias(newN, targetN: string);
begin
   SetLength(AliasList, AliasCount + 1);
   AliasList[AliasCount].NewName:= newN;
   AliasList[AliasCount].TargetName:= targetN;
   Inc(AliasCount);
end;

procedure AddAliasChar(newC, targetC: char);
begin
   SetLength(AliasCharList, AliasCharCount + 1);
   AliasCharList[AliasCharCount].NewChar:= newC;
   AliasCharList[AliasCharCount].TargetChar:= targetC;
   Inc(AliasCharCount);
end;

end.
